<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~cdna_registration.js" 
	styles="path.css,~../css/reggie-2.css"
	>
<style>
.date-col
{
	width: 12em;
}

.operator-col input
{
	width: 95%;
}
</style>

</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="cDNA registration" 
		/></p:path>

	<div class="content">

	<form name="reggie" id="wizard" class="wizard">

	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select cDNA bioplate</div>
		<div class="step-content">
	
			<table class="step-form">
			<tr valign="top">
				<td class="prompt">cDNA bioplate</td>
				<td class="input">
					<select class="required" name="bioplate" id="bioplate"></select>
				</td>
				<td class="status" id="bioplate.status"></td>
				<td class="help">
					<span id="bioplate.message" class="message"></span>
					Select an existing cDNA bioplate. The list contain all cDNA bioplates that
					has not yet been processed (determined by the absence of a 'creation' date).
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Outcome</td>
				<td class="input">
					<label><input type="radio" name="outcome" id="outcomeSuccess" 
						onchange="outcomeOnChange()" checked>Success</label> - continue with library preparation<br>
					<label><input type="radio" name="outcome" id="outcomeFailed" 
						onchange="outcomeOnChange()">Failure</label> - no further processing to libraries
				</td>
				<td class="status"></td>
				<td class="help">
					Select the <b>Failure</b> option if further processing to cDNA is not possible.
					No child cDNA plate will be created and existing RNA will be flagged and added
					to the <b>Flagged RNA</b> list.
				</td>
			</tr>
			</table>
		</div>
	</div>
				
	<div class="step" id="step-2">
		<div class="step-no">2</div>
		<div class="step-title">cDNA preparation information</div>
		<div class="step-content">
		
			<table class="step-form">
			<tr>
				<td class="prompt">Step</td>
				<td class="date-col"><b>Date</b></td>
				<td class="operator-col"><b>Operator</b></td>
				<td class="status"></td>
				<td class="help" rowspan="2">
					Enter date and operator for each step in the cDNA preparation.
					(YYYYMMDD or MMDD)
				</td>
			</tr>
			<tr>
				<td class="subprompt">Synthesis</td>
				<td class="date-col">
					<input type="text" name="synthesisDate" id="synthesisDate"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="synthesisOperator"
						style="width: 8em;" maxlength="10">
						<base:icon 
							id="synthesisDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="synthesisDate"
							data-date-format="yyyyMMdd"
							data-title="Synthesis date"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="operator-col">
					<input type="text" name="synthesisOperator" id="synthesisOperator" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="cdnaProtocol"
						value="<%=HTML.encodeTags(user.getName())%>" maxlength="255">
				</td>
				<td class="status" id="synthesisDate.status"></td>
			</tr>

			<tr>
				<td class="prompt">Protocol</td>
				<td class="input" colspan="2">
					<select name="cdnaProtocol" id="cdnaProtocol" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="comments"
						></select>
				</td>
				<td class="status" id="cdnaProtocol.status"></td>
				<td class="help">
					<span id="cdnaProtocol.message" class="message"></span>
					Select the protocol which was used in the cDNA preparation.
				</td>
			</tr>
			<tr class="align-top">
				<td class="prompt">Comments</td>
				<td class="input" colspan="2">
					<textarea name="comments" id="comments" rows="4"></textarea></td>
				<td class="status" id="comments.status"></td>
				<td class="help">
					<span id="comments.message" class="message"></span>
					Comments about the cDNA preparation.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>