<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.List"
	import="java.util.ArrayList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final String root = request.getContextPath();
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final Extension reggie = ExtensionsControl.get(dc).getExtension("net.sf.basedb.reggie");
	final User user = User.getById(dc, sc.getLoggedInUserId());
	int neoPrepPlateId = Values.getInt(request.getParameter("bioplate"));
	final Float stratageneConc = Values.getFloat(request.getParameter("stratageneConc"), null);
	
	BioPlate plate = BioPlate.getById(dc, neoPrepPlateId);
	int columns = plate.getColumns();
	int rows = plate.getRows();
	String view = Values.getString(request.getParameter("view"), "list");
	String title = "Lab protocol for " + HTML.encodeTags(plate.getName()) + " - " + (view.equals("list") ? "list" : "table");
%>
<base:page id="protocol" type="iframe" favicon="<%=home+"/images/pipette.png"%>" title="<%=title%>" noskin="true">
<base:head
	scripts="~../reggie-2.js,~pools.js,~plate.js,~neoprep_protocol.js" 
	styles="~../css/reggie-2.css,~../css/printable.css,~../css/plate.css"
	>
	<style>
	table.protocolheader
	{
		width: 100%;
		border: 1px solid #000000;
		margin-bottom: 1em;
		border-collapse: collapse;
	}

	table.protocolheader > tbody > tr
	{
		vertical-align: top;
		height: 1.25em;
	}

	table.protocolheader > tbody > tr > th
	{
		text-align: left;
		font-size: 1em;
		background-color: #F0F0F0;
		padding: 2px;
	}
	
	table.protocolheader > tbody > tr > td
	{
		text-align: left;
		font-size: 1em;
		padding: 2px;
	}
	
	#listview
	{
		width: 100%;
		font-size: 85%;
		border-collapse: collapse;
		border: 1px solid #000000;
	}
	
	#listview tr.evencol
	{
		background-color: #F0F0F0;
	}
	
	#listview thead
	{
		border: 1px solid #000000;
		background-color: #F0F0F0;
	}
	
	#listview tbody
	{
		page-break-inside: avoid;
		border-top: 1px solid #000000;
		border-bottom: 1px solid #000000;
	}
	
	#listview th
	{
		border-left: 1px solid #000000;
	}
	
	#listview td
	{
		border-left: 1px solid #000000;
		border-top: 1px dotted #666666;
		vertical-align: middle;
	}
	
	#listview .col-num
	{
		width: 1.75em;
		text-align: center;
		font-size: 125%;
		font-weight: bold;
		vertical-align: top;
	}
	
	#listview .rna
	{
		width: 9em;
		text-align: center;
	}
	
	#listview .empty .rna
	{
		font-style: italic;
		color: #666666;
		text-align: center;
	}
	
	.external .rna:before
	{
		content: '[';
	}
	.external .rna:after
	{
		content: ']';
	}
	
	#listview .box
	{
		width: 8em;
		text-align: center;
	}
	#listview .workplate
	{
		width: 5em;
		text-align: center;
	}
	#listview .ndconc
	{
		width: 4.5em;
		padding-right: 0.5em;
		text-align: right;
	}
	#listview .remain
	{
		width: 4.5em;
		padding-right: 0.5em;
		text-align: right;
	}
	#listview .volume
	{
		width: 3.5em;
		padding-right: 0.5em;
		text-align: right;
		color: #C80000;
	}
	#listview .water
	{
		width: 3.5em;
		padding-right: 0.5em;
		text-align: right;
		border-left-style: dotted;
	}
	
	#listview td.water
	{
		color: #0000C8;
	}
	
	#listview .barcode
	{
		width: 6em;
		text-align: center;
		border-left-style: dotted;
	}
	#listview .remarks
	{
		vertical-align: top;
		padding-left: 0.25em;
	}
	
	/* Divide the 12 wells across the full page */
	#plateview .well
	{
		background-color: #FFFFFF;
		padding: 4px;
	}
	
	#plateview .well:hover
	{
		padding: 3px;
	}
		
	#plateview .rowheader
	{
		width: 2em;
	}
	
	#plateview .rna
	{
		font-weight: bold;
		margin-bottom: 0.25em;
	}
	#plateview .box
	{
		margin-bottom: 0.25em;
	}
	#plateview .ndconc
	{
		display: none;
	}
	#plateview .remain
	{
		display: none;
	}
	#plateview .volume
	{
		color: #C80000;
	}
	#plateview .water
	{
		color: #0000C8;
		float: right;
	}
	#plateview .remarks
	{
		color: #C80000;
		font-style: italic;
	}
	#plateview .qc
	{
		background-image: url('../images/mrnaqc.png');
		background-position: 95% 25%;
		background-repeat: no-repeat;
	}
	</style>
</base:head>
<base:body>

	<div class="paper">

	<form name="reggie" id="wizard">
	
	<div id="page-data" class="datacontainer"
		data-view="<%=view%>"
		data-neoprep-plate="<%=neoPrepPlateId %>"
		data-stratagene-conc="<%=stratageneConc%>"
	></div>
	
	<div id="wizard-status"></div>

	<div id="all-protocol" style="display: none;">
	<div id="print-instructions" class="noprint fullwidth">
		<base:button id="print-button" image="<%=home+"/images/print.png"%>" title="Print&hellip;" />
		<span id="printNote">
		<b>Note!</b> 
		<%
		if (view.equals("list"))
		{
			%>
			For better printing reduce margins to about <i>5mm</i> and set page orientation
			to <i>portrait</i>. To fit everything on a single page, scale down to <i>60-70%</i>.
			<%
		}
		else
		{
			%>
			For better printing reduce margins to about <i>5mm</i> and set page orientation
			to <i>portrait</i>. The recommended scale is <i>100%</i>.
			<%
		}
		%>
		</span>
		<br clear="all">
	</div>

	
	<h1>Lab protocol for NeoPrep library preparation <span class="reggie">Reggie <%=reggie.getAbout().getVersion() %></span></h1>

	<table style="width: 100%;" class="protocolheader">
	<tr style="border-bottom: 1px solid #000000;">
		<th style="width: 15%;">Work plate</th>
		<td style="width: 30%; border-right: 1px solid #000000;"><%=HTML.encodeTags(plate.getName())%></td>
		<th style="border-right: 1px solid #000000;" colspan="3">Libraries</th>
	</tr>
	<tr>
		<td rowspan="6" colspan="2" style="width: 50%; border-right: 1px solid #000000;"><%=HTML.niceFormat(plate.getDescription()) %></td>
		<th style="border-right: 1px solid #000000;">Volume</th>
		<td style="border-right: 1px solid #000000;">10 µl</td>
		<td></td>
	</tr>
	<tr valign="top" style="border-top: 1px solid #CCCCCC;">
		<th style="border-right: 1px solid #000000;">Molarity</th>
		<td style="border-right: 1px solid #000000;">10 nM</td>
		<td></td>
	</tr>
	<tr valign="top" style="border-top: 1px solid #CCCCCC;">
		<th style="border-right: 1px solid #000000;">Size</th>
		<td style="border-right: 1px solid #000000;">300 BP</td>
		<td></td>
	</tr>
	<tr style="border-top: 1px solid #000000;">
		<th style="width: 15%;"></th>
		<th style="width: 20%;">Date</th>
		<th style="width: 20%;">Operator</th>
	</tr>
	<tr style="border-top: 1px solid #000000;">
		<td style="border-right: 1px solid #000000;">Dilution</td>
		<td style="border-right: 1px solid #000000;" id="dilution-date"></td>
		<td id="dilution-operator"></td>
	</tr>
	<tr style="border-top: 1px solid #CCCCCC;">
		<td style="border-right: 1px solid #000000;">NeoPrep</td>
		<td style="border-right: 1px solid #000000;"></td>
		<td></td>
	</tr>
	</table>

	<%
	if (view.equals("list"))
	{
		%>
		<table style="width: 100%;" id="listview">
		<thead>
			<tr class="toprow">
				<th></th>
				<th class="rna"></th>
				<th class="box">Storage</th>
				<th>NDConc</th>
				<th>Remain</th>
				<th class="workplate">Library</th>
				<th colspan="2">Volume</th>
				<th colspan="2">TruSeq</th>
				<th></th>
			</tr>
			<tr>
				<th></th>
				<th class="rna">RNA</th>
				<th class="box">box</th>
				<th>(ng/µl)</th>
				<th>(µg)</th>
				<th class="workplate">card</th>
				<th>(µl)</th>
				<th class="water">H<sub>2</sub>O</th>
				<th colspan="2">index</th>
				<th>Remarks</th>
			</tr>
		</thead>
		<%
		WellCoordinateFormatter rowF = new WellCoordinateFormatter(true);
		WellCoordinateFormatter colF = new WellCoordinateFormatter(false);
		for (int c = 0; c < columns; ++c)
		{
			String rowClass = c % 2 == 0 ? "evencol" : "oddcol";
			%>
			<tbody>
			<%
			for (int r = 0; r < rows; ++r)
			{
				String idSuffix = c + "." + r;
				%>
				<tr class="<%=rowClass%> empty" id="row.<%=idSuffix%>">
					<%
					if (r == 0)
					{
						%>
						<td class="col-num" rowspan="<%=rows%>"><%=c+1%></td>
						<%
					}
					%>
					<td class="rna" id="rna.<%=idSuffix%>">empty</td>
					<td class="box" id="box.<%=idSuffix%>"></td>
					<td class="ndconc" id="ndconc.<%=idSuffix%>"></td>
					<td class="remain" id="remain.<%=idSuffix%>"></td>
					<td class="workplate"><%=(r+c*rows+1)%></td>
					<td class="volume" id="volume.<%=idSuffix%>"></td>
					<td class="water" id="water.<%=idSuffix%>"></td>
					<td class="workplate"><%=rowF.format(r+c*rows)%></td>
					<td class="barcode" id="barcode.<%=idSuffix%>"></td>
					<td class="remarks" id="remarks.<%=idSuffix%>"></td>
				</tr>
				<%
			}
			%>
			</tbody>
			<%
		}
		%>
		</table>
		<%
	}
	else
	{
		%>
		<table class="plate neoprep" style="margin: 0 auto 0 auto; " id="plateview">
		<%
		WellCoordinateFormatter rowF = new WellCoordinateFormatter(true);
		WellCoordinateFormatter colF = new WellCoordinateFormatter(false);
		%>
		<tr class="header">
			<td class="barcode-fill barcode-left"></td>
			<th></th>
			<th colspan="<%=columns%>"><%=HTML.encodeTags(plate.getName())%></th>
			<th style="border-bottom: 0;"></th>
			<td class="barcode-fill barcode-right"></td>
		</tr>
		<tbody>
		<%
		for (int r = 0; r < rows; ++r)
		{
			String row = rowF.format(r);
			%>
			<tr class="row-<%=r%>">
				<td class="barcode-well barcode-left" id="barcode.<%=r%>.0" data-col="0" data-row="<%=r%>"></td>
				<th id="row.<%=r%>" class="rowheader"><%=row%><br><span style="border-top: 1px solid #A0A0A0;"><%=r+1 %></span></th>
				<%
				for (int c = 0; c < columns; ++c)
				{
					%>
					<td class="well col-<%=c%>" id="well.<%=r%>.<%=c%>"></td>
					<%
				}
				%>
				<th id="row.<%=r%>.2" class="rowheader"><%=rowF.format(r+rows)%><br><span style="border-top: 1px solid #A0A0A0;"><%=r+rows+1 %></span></th>
				<td class="barcode-well barcode-right" id="barcode.<%=r%>.1" data-col="1" data-row="<%=r%>"></td>
			</tr>
			<%
		}
		%>
		</tbody>
		<tr id="pool-row">
			<td class="barcode-fill barcode-left"></td>
			<th colspan=<%=columns+1 %>>&nbsp;</th>
			<td class="barcode-fill barcode-right"></td>
		</tr>
		</table>
		<%
	}
	%>
	<i>Low quantity = The remaining quantity is too low for the RNA to be re-processed one more time</i>
</div>
</form>
</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>