<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~retraction_followup_form.js" 
	styles="path.css,~../css/reggie-2.css"
/>
<base:body>

	<p:path><p:pathelement id="reggie-index"
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Retraction follow-up" 
		/></p:path>

	<div class="content">
	<form name="reggie" id="wizard" class="wizard">

		<div class="step" id="step-1">
			<div class="step-no">1</div>
			<div class="step-title">Enter Case Name or Personal Number</div>
			<div class="step-content">

				<table class="step-form">
				<tr>
					<td class="prompt">Case name or personal number</td>
					<td class="input"><input type="text" name="caseName" id="caseName"
						class="required auto-init" data-auto-init="focus"
						style="width: 12em;" maxlength="12"></td>
					<td class="status" id="caseName.status"></td>
					<td class="help">
						<span id="caseName.message" class="message"></span>
						The 7-digit case (barcode) associated with the case, or personal number (YYYYMMDDZZZZ).
					</td>
				</tr>
				</table>

			</div>
		</div>

		<div class="step" id="step-2">
			<div class="step-no">2</div>
			<div class="step-title">Retraction follow-up</div>
			<div class="step-content">

				<div id="retractTable"></div>
				<table class="step-form" id="functionmodifiers">
				<tr>
					<td class="prompt">Patient</td>
					<td class="input">
						Name <input type="text" name="patientName" id="patientName"
							class="auto-init" data-auto-init="focus-on-enter" data-next-focus="patientRegistrationDate"
							style="width: 10em;" maxlength="15">
						Registration date <input type="text" name="patientRegistrationDate" id="patientRegistrationDate"
							class="auto-init" data-auto-init="focus-on-enter" data-next-focus="labSentDate"
							style="width: 10em;" maxlength="10"></span>
					</td>
					<td class="status" id="patientInfo.status"></td>
					<td class="help">
						<span id="patientInfo.message" class="message"></span>
						Info for current patient
					</td>
				</tr>
				<tr>
					<td class="prompt">Laboratory</td>
					<td class="input">
						Date sent <input type="text" name="labSentDate" id="labSentDate"
							class="auto-init" data-auto-init="focus-on-enter" data-next-focus="labReceivedDate"
							style="width: 10em;" maxlength="10">
						Date received <input type="text" name="labReceivedDate" id="labReceivedDate"
							class="auto-init" data-auto-init="focus-on-enter" data-next-focus="bloodSentDate"
							style="width: 10em;" maxlength="10"></span>
					</td>
					<td class="status" id="labDate.status"></td>
					<td class="help">
						<span id="labDate.message" class="message"></span>
						Dates when retraction request sent and received to/from laboratory (YYYYMMDD)
					</td>
				</tr>
				<tr>
					<td class="prompt">Blood samples</td>
					<td class="input">
						Date sent <input type="text" name="bloodSentDate" id="bloodSentDate"
							class="auto-init" data-auto-init="focus-on-enter" data-next-focus="bloodReceivedDate"
							style="width: 10em;" maxlength="10">
						Date received <input type="text" name="bloodReceivedDate" id="bloodReceivedDate"
							class="auto-init" data-auto-init="focus-on-enter" data-next-focus="frozenSentDate"
							style="width: 10em;" maxlength="10"></span>
					</td>
					<td class="status" id="bloodDate.status"></td>
					<td class="help">
						<span id="bloodDate.message" class="message"></span>
						Dates when retraction request sent and received for blood samples (YYYYMMDD)
					</td>
				</tr>
				<tr>
					<td class="prompt">Frozen samples</td>
					<td class="input">
						Date sent <input type="text" name="frozenSentDate" id="frozenSentDate"
							class="auto-init" data-auto-init="focus-on-enter" data-next-focus="frozenReceivedDate"
							style="width: 10em;" maxlength="10">
						Date received <input type="text" name="frozenReceivedDate" id="frozenReceivedDate"
							class="auto-init" data-auto-init="focus-on-enter" data-next-focus="forwardedSentDate"
							style="width: 10em;" maxlength="10"></span>
					</td>
					<td class="status" id="frozenDate.status"></td>
					<td class="help">
						<span id="frozenDate.message" class="message"></span>
						Dates when retraction request sent and received for frozen samples (YYYYMMDD)
					</td>
				</tr>
				<tr>
					<td class="prompt">Forwarded</td>
					<td class="input">
						Date sent <input type="text" name="forwardedSentDate" id="forwardedSentDate"
							class="auto-init" data-auto-init="focus-on-enter" data-next-focus="rccSydSentDate"
							style="width: 10em;" maxlength="10">
					</td>
					<td class="status" id="forwardedDate.status"></td>
					<td class="help">
						<span id="forwardedDate.message" class="message"></span>
						Date when retraction request forwarded to other projects (YYYYMMDD)
					</td>
				</tr>
				<tr>
					<td class="prompt">RCC Syd notification</td>
					<td class="input">
						Date sent <input type="text" name="rccSydSentDate" id="rccSydSentDate"
							class="auto-init" data-auto-init="focus-on-enter" data-next-focus="goRegister"
							style="width: 10em;" maxlength="10">
					</td>
					<td class="status" id="rccSydDate.status"></td>
					<td class="help">
						<span id="rccSydDate.message" class="message"></span>
						Date when retraction notification sent to RCC Syd (YYYYMMDD)
					</td>
				</tr>
				</table>
			</div>
		</div>

		<div id="wizard-status"></div>

		<table class="navigation" id="navigation">
		<tr>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
			<td><base:button id="gocancel" title="Cancel" /></td>
			<td><base:button id="goregister" title="Register" image="<%=home+"/images/gonext.png"%>" /></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
			<td id="gonext-message" class="message"></td>
		</tr>
		</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>